## 实验一
### 题目
利用uCore的中断机制，编程实现一个计时器（ 秒表 ），可以实现正计时和倒计时。先选择计时模式，输入“A”为正计时，“B”为倒计时。若选择倒计时，则要先输入初始时间（秒数）。按“S”开始正（倒）计时，按“P”暂停正（倒）计时，按“C”继续正（倒）计时，按“E”停止正（倒）计时，暂停正（倒）计时或停止正（倒）计时时显示计时（剩余）时间值（秒数）。（时间精确到0.1秒）
### 效果
![](assets/实验一演示.gif)
### 原理
在trap.c文件中，在计时器中断（IRQ_OFFSET + IRQ_TIMER）和键盘中断（IRQ_OFFSET + IRQ_KBD）的部分添加状态转换、输入、输出。

## 实验二
### 题目
在现有的物理块分配首次适应算法基础上，实现循环首次适应算法。
### 效果
![](assets/实验二演示.gif)
### 原理
在default_pmm.c文件中，修改default_alloc_pages（或者新建一个函数），记录下循环首次适应算法的指针，每次从该指针的位置开始继续查找下一个空闲块。（原有的测试函数default_check、basic_check也需要略微更改）